--[[
	MAIN DRAW SCRIPT
]]--

function draw()
	if state == "title" then
		--title screen?
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(g_title, 0, 0)
		--love.graphics.print(# menu_handler, 100, 100)
		love.graphics.setColor(100, 255, 100, 255)
		
		--slimes
		for _, t in ipairs(title_slimes) do
			t:draw()
		end
		--love.graphics.print("UnLove", love.graphics.getWidth() / 2 - 20, love.graphics.getHeight() / 3)
		--love.graphics.setColor(math.floor(title_glow), 200, math.floor(title_glow), 255)
		--love.graphics.print("Press Return for a new game", 10, 300)
		love.graphics.setColor(255, 255, 255, math.floor(tfade))
		love.graphics.print("Arrow keys: Move", 10, 240)
		love.graphics.print("Space: Attack", 10, 260)
		love.graphics.print("Right Shift: Switch Weapon", 10, 280)
		love.graphics.print("Escape: Return to title", 10, 300)
		love.graphics.print("Audio: F1 [" .. love.audio.getVolume() .. "]", 300, 260)
		love.graphics.print("Blood Effects: F8", 300, 280)
		love.graphics.setColor(200, 10, 10, math.floor(tfade))
		if prefs.gore == "full" then
			love.graphics.print("Full (Uses Framebuffers)", 300, 300)
		elseif prefs.gore == "low" then
			love.graphics.print("Low", 300, 300)
		else
			love.graphics.print("Off (Wuss)", 300, 300)
		end
		
 
	elseif state == "action" then
		--temp background
		love.graphics.setColor(37, 55, 27, 255)
		love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
		
		--blood
		if prefs.gore == "full" and player1.score ~= 0 then
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.draw(blood_buffer, 0, 0)
		elseif prefs.gore == "low" then
			for _, zb in ipairs(bloodshed) do
				zb:draw()
			end
		end
				
		--items
		for _, i in ipairs(item_stack) do
			i:draw()
		end
				
		--zombies
		for _, zy in ipairs(zombies) do
			zy:draw()
		end
		
		
		--player
		player1:draw()
		
	elseif state == "gameover" then
		--temp background
		--love.graphics.setColor(100, 50, 50, 255)
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.draw(g_over, 0, 0)
		love.graphics.print("Oh noes! It appears that you have been eaten by zombies D:", 20, 20)
		love.graphics.print("Press Return for a new game. Escape to return to the title screen.", 20, 70)
		love.graphics.print("Enter name for highscore: " .. player1.name .. blinky, 20, 90)
		love.graphics.setColor(63, 37, 37, 255)
		love.graphics.print("But you got " .. math.floor(player1.score) ..  " points... ", 20, 40)
	end
	
	--cross-state drawing ops!
	for _, m in ipairs(menu_handler) do
		m:draw()
	end
end