--[[
	ITEMS
]]--
class "item" {
	__init__ = function(self, x, y, bonus)
		self.x = x or 0
		self.y = y or 0
		if bonus then
			self.w = bonus.name:len() * 5
		else
			self.w = 8
		end
		self.bonus = {}
		self.bonus = bonus or nil
		self.color = {20, 20, 125, 255}
		self.flash = 0
	end,
	
	update = function(self, dt)
		self.flash = self.flash + (10 * dt)
		if self.flash > 1 then
			self.color = {255, 255, 255, 255}
			self.flash = 0
		else
			self.color = {20, 20, 125, 255}
		end
		
		self:pickup(player1)
	end,
	
	draw = function(self)
		love.graphics.setColor(self.color)
		if not self.bonus then
			love.graphics.rectangle("fill", self.x, self.y, 8, 8)
		else
			love.graphics.print(self.bonus.name, self.x, self.y)
		end
	end,
	
	pickup = function(self, player)
		if overlap(self.x, self.y, self.w, 8, player.x, player.y, player.w, player.h) then
			s_item_get:stop()
			s_item_get:play()
			self.x = -200
			if not self.bonus then
				player.hp = player.hp + 250 --default, restores health
				player.score = player.score + 25
			else
				table.insert(player.weapons, self.bonus)
				player.equipped = # player.weapons
				player.score = player.score + ((self.bonus.ammo * self.bonus.dmg) * 2)
			end
		end
	end
}