class "player" {
	__init__ = function(self, name)
		self.name = name
		self.x = 0
		self.y = 0
		self.vx = 0
		self.vy = 0
		self.w = 16
		self.h = 16 --width/height need working into more things, such as display of weapons?
		self.speed = 125
		self.weapons = {}
		self.equipped = 1
		self.hp = 1000
		self.color = {255, 255, 255, 255}
		self.act = ""
		self.cool = 0
		self.dir = "s"
		self.atkok = 1
		self.status = nil
		self.score = 0
		self.hpulse = 256
		self.hpulse2 = 0
	end,
	
	control = function(self, dt)
		--CONTROLS
		local k_up = love.keyboard.isDown(prefs.up)
		local k_down = love.keyboard.isDown(prefs.down)
		local k_left = love.keyboard.isDown(prefs.left)
		local k_right  = love.keyboard.isDown(prefs.right)
		local k_change = love.keyboard.isDown(prefs.alt)
		
		--switch weapons
		if k_change and not k_change1 then
			s_wpn_change:stop()
			s_wpn_change:play()
			k_change1 = true
			self.equipped = self.equipped + 1
			if self.equipped > # self.weapons then
				self.equipped = 1
			end
		elseif not k_change then
			k_change1 = nil
		end
		
		--attaaaaaaaaaack!!
		local k_atk = love.keyboard.isDown(prefs.fire)
		if k_atk and self.cool == 0 and self.atkok == 1 then
			--attack
			self.weapons[self.equipped].sfx:stop()
			self.weapons[self.equipped].sfx:play()
			self.act = "atk"
			self.cool = 0.25
			self.atkok = 0
		end
		
		if self.cool > 0 then
			self.cool = self.cool - 2 * dt
			if self.cool <= 0 then self.cool = 0 end
			
		else
			if not k_atk then self.atkok = 1 end
			--up/down
			if k_up and not k_down then
				self.vy = self.vy - self.speed * dt
				self.dir = "n"
			elseif k_down and not k_up then
				self.vy = self.vy + self.speed * dt
				self.dir = "s"
			end
			--left/right
			if k_left and not k_right then
				self.vx = self.vx - self.speed * dt
				self.dir = "w"
			elseif k_right and not k_left then
				self.vx = self.vx + self.speed * dt
				self.dir = "e"
			end
			self.act = "move"
		end
	end,
	
	update = function(self, dt)		
		--reposition
		self.x = self.x + self.vx
		self.y = self.y +self.vy
		
		--check bounds
		if self.x <= 1 then self.x = 1 end
		if self.x >= love.graphics.getWidth() - 17 then self.x = love.graphics.getWidth() - 17 end
		if self.y <= 18 then self.y = 18 end
		if self.y >= love.graphics.getHeight() - 17 then self.y = love.graphics.getHeight() - 17 end
		
		self.vx = 0
		self.vy = 0
		
		--lowhealth stuff
		if s_hit:isStopped() then
			s_hit:play()
		end
		local vol = 0.5 - ((self.hp / 1000) / 2)
		s_hit:setVolume(vol)
		
		self.hpulse = self.hpulse + self.hpulse2
		if self.hpulse > 50 then
			self.hpulse2 = -100 * dt
			self.hpulse = 50
		elseif self.hpulse < 0 then
			self.hpulse2 = 100 * dt
			self.hpulse = 0
		end 
		
		--check weapon breaks
		if self.weapons[self.equipped].ammo and self.weapons[self.equipped].ammo < 1 then
			s_item_break:stop()
			s_item_break:play()
			table.remove(self.weapons, self.equipped)
			self.equipped = self.equipped + 1
			if self.equipped > # self.weapons then
				self.equipped = self.equipped - 2
			end
		end		
		--check4dead
		if self.hp <= 0 then
			self.status = "dead"
			s_hit:stop()
		end
		
		--check if the zombie was attacked and make it invincible for a second
		if self.inv then
			self.inv = self.inv - (10 * dt)
			if self.inv <= 0 then self.inv = nil end
		end

		
	end,
	
	draw = function(self)
		--graphic
		if not self.inv then
			love.graphics.setColor(self.color)
			self.flash = nil
		else
			if math.floor(self.inv) % 2 == 0 then
				if not self.flash or self.flash == 0 then
					self.flash = 255
				else
					self.flash = 0
				end
			end
		love.graphics.setColor(255, 255, 255, self.flash)
		end

		love.graphics.rectangle("fill", math.floor(self.x), math.floor(self.y), 16, 16)
				
		--weapon
		if self.act == "atk" then
			if self.weapons[self.equipped].color[4] ~= 255 then	
				love.graphics.setBlendMode("additive")
			end
			love.graphics.setColor(self.weapons[self.equipped].color)
			if self.dir == "n" then 
				love.graphics.rectangle("fill", math.floor(self.x + (self.w / 2) - (self.weapons[self.equipped].w / 2)), math.floor(self.y - self.weapons[self.equipped].h), self.weapons[self.equipped].w, self.weapons[self.equipped].h)
			elseif self.dir == "e" then
				love.graphics.rectangle("fill", math.floor(self.x + self.w), math.floor(self.y + (self.h / 2) - (self.weapons[self.equipped].w / 2)), self.weapons[self.equipped].h, self.weapons[self.equipped].w)
			elseif self.dir == "s" then
				love.graphics.rectangle("fill", math.floor(self.x + (self.w / 2) - (self.weapons[self.equipped].w / 2)), math.floor(self.y + self.h), self.weapons[self.equipped].w, self.weapons[self.equipped].h)
			else
				love.graphics.rectangle("fill", math.floor(self.x - self.weapons[self.equipped].h), math.floor(self.y + (self.h / 2) - (self.weapons[self.equipped].w / 2)), self.weapons[self.equipped].h, self.weapons[self.equipped].w)
			end
			love.graphics.setBlendMode("alpha")
		end
		
		--DRAW HUD ELEMENTS
		--bg
		love.graphics.setColor(0, 0, 0, 125)
		love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), 17)
		--misc
		love.graphics.setColor(self.color)
		love.graphics.print("HP ", 2, 2)
		love.graphics.print("[" .. self.equipped .. "/" .. # self.weapons .. "]Weapon: " .. self.weapons[self.equipped].name, 75, 2)
		love.graphics.print("Score: " .. math.floor(self.score), 390, 2)
		--weapon ammo
		if self.weapons[self.equipped].ammo then
			love.graphics.setColor(255, (self.weapons[self.equipped].ammo / self.weapons[self.equipped].maxammo) * 255, (self.weapons[self.equipped].ammo / self.weapons[self.equipped].maxammo) * 255, 255)
			love.graphics.rectangle("fill", 75, 14, (self.weapons[self.equipped].ammo / self.weapons[self.equipped].maxammo) * 200, 2)
		end
		--health percentage
		local hpcol = self.hp
		if hpcol > 1000 then hpcol = 1000 end
		love.graphics.setColor(255 - math.floor((hpcol / 1000) * 255), 120 - math.floor(self.hpulse), 50 - math.floor(self.hpulse), 255)
		love.graphics.print(math.floor((self.hp / 1000) * 100) .. "\%", 25, 2)
		--love.graphics.print(# self.weapons, 30, 30)
	end
}