--[[
	MAIN LOAD SCRIPT
]]--

function dj_load()
	--randomise seed and stuff
	math.randomseed(os.time())
	rnrnrn = math.random()
	rnrnrn = math.random()
	rnrnrn = math.random()
	rnrnrn = nil
	
	--misc setups
	love.mouse.setVisible(false)
	menu_handler = {} --menu handler!
	
	sys_fpath = love.filesystem.getAppdataDirectory()
	highscores = {}
	local l, t = 0, 0
	--if highscores file is present then load the fucker
	if love.filesystem.exists("highscores.zom") then
		for hs in love.filesystem.lines("highscores.zom") do
  			if t == 0 then
  				highscores[l].score = hs
  				t = 1
  			else
  				highscores[l].name = hs
  				t = 0
  				l = l + 1
  			end
		end
	else
		--create
	end
		

	--images
	g_title = love.graphics.newImage("gfx/title.png")
	g_over = love.graphics.newImage("gfx/deads.png")

	--sound effects and that
	s_knife = love.audio.newSource("sfx/knife.ogg", "static")
	s_knife:setVolume(0.5)
	s_hit = love.audio.newSource("sfx/drain.ogg", "static")
	s_hit:setLooping(true)
	s_hit:setVolume(0)
	s_dmg = love.audio.newSource("sfx/ouch.ogg", "static")
	s_dmg:setPitch(1.75)
	s_zom_spawn = love.audio.newSource("sfx/spawn.ogg", "static")
	s_zom_dmg = love.audio.newSource("sfx/z_hit.ogg", "static")
	s_zom_death = love.audio.newSource("sfx/z_dead.ogg", "static")
	s_creepy = love.audio.newSource("sfx/deads.ogg", "static")
	s_creepy:setLooping(true)
	s_drone = love.audio.newSource("sfx/drone.ogg", "static")
	s_drone:setLooping(true)
	s_drone:setVolume(0.25)
	s_item_get = love.audio.newSource("sfx/item_get.ogg", "static")
	s_item_get:setVolume(0.5)
	s_item_break = love.audio.newSource("sfx/item_break.ogg", "static")
	s_item_break:setVolume(0.5)
	s_start = love.audio.newSource("sfx/game_startoh.ogg", "satic")
	s_start:setVolume(0.5)
	s_magick = love.audio.newSource("sfx/magick.ogg", "static")
	s_scroll = love.audio.newSource("sfx/change.ogg", "static")
	s_tslime = {}
	for i = 1, 5 do
		s_tslime[i] = love.audio.newSource("sfx/bloop.ogg", "static")
	end
	--default preferences?
	prefs = {}
	prefs.up = "up"
	prefs.down = "down"
	prefs.left = "left"
	prefs.right = "right"
	prefs.fire = " "
	prefs.alt = "rshift"
	prefs.gore = "full" 
	
	
	--some weapons
	knife = wpn("Knife")
	short = wpn("Short Sword", 1, 30, 6, 14, 2)
	broad = wpn("Broad Sword", 1.3, 20, 10, 16, 2)
	long = wpn("Long Sword", 1.3, 20, 6, 20, 3)

	--development/test code
	state = "title"
	pause_menu = menu("Paused", love.graphics.getWidth() / 4, (love.graphics.getHeight() / 2) - 16, "Press Enter to resume")
	title_menu = menu("Main Menu", 10, 100, "Start New Game")
	title_menu.elements[1].ref = function(parent)
									function love.keypressed() end
									s_start:stop()
									s_start:play()
									dev_init()
									parent.close = true
								end
	title_menu.elements[2] = menu_element("High Scores", function() end)
	title_menu.elements[3] = menu_element("Options", function() end)
	title_menu.elements[4] = menu_element("Quit", function() love.event.push('q') end)
	title_init()
end

function dev_init()
	--audio init
	s_drone:play()
	
	--player setup
	player1 = player("UnLove")
	table.insert(player1.weapons, knife)
	--table.insert(player1.weapons, short)
	
	--zombies
	zombies_deadcheck = {}
	zombies = {}
	zombies[1] = zombie(player1)
	zombies[2] = zombie(player1)
	zombies[3] = zombie(player1)
	
	--gamestate
	state = "action"
	add_more = 0
	
	--blood!
	bloodshed = {}
	if prefs.gore == "full" then
		blood_buffer = love.graphics.newFramebuffer()
		blood_data = love.image.newImageData(love.graphics.getWidth(), love.graphics.getHeight())
		blood_raster = nil
	end
	--items
	item_stack = {}
	table.insert(item_stack, item(250, 250, wpn("Short Sword", 1, 30, 6, 14, 2)))
	--table.insert(item_stack, item(150, 150, wpn("Magick Sword", 4, 20, 8, 16, 6, "stab", {255, 175, 100, 175}, s_magick)))
end

function title_init()
	title_slimes = {}
	title_glow = 99
	tfade = 255
	tfader = 0
	tglower = 0
	tsfx = 1
	pads = love.joystick.getNumJoysticks()
	love.joystick.open(0)
	table.insert(menu_handler, title_menu)
end