--[[
	UPDATE SCRIPT
]]--
function update(dt)
	--inter-state operations!
	if love.keyboard.isDown("f1") and not k_f1 then
		k_f1 = true
		if love.audio.getVolume() ~= 0 then
			love.audio.setVolume(0)
		else
			love.audio.setVolume(1)
			s_scroll:stop()
			s_scroll:play()
		end
	elseif not love.keyboard.isDown("f1") then
		k_f1 = nil
	end
	
	if # menu_handler >= 1 then
		prefs.pause = true
		menu_handler[# menu_handler]:update(dt)
		if menu_handler[# menu_handler].close then
			menu_handler[# menu_handler].close = nil
			table.remove(menu_handler, # menu_handler)
		end
	elseif prefs.pause then
		prefs.pause = nil
	end
	
	--gamestates
	--TITLE SCREEN-----------------------------------------------------------+
	if state == "title" then
		--controller dev
		buttons = ""
		for b = 0, love.joystick.getNumButtons(0) do
			if love.joystick.isDown(0, b) then
				buttons = buttons .. " " .. b
			end
		end
		for b = 0, love.joystick.getNumAxes(0) do
				buttons = buttons .. " " .. math.floor(love.joystick.getAxis(0, b) * 100)
		end
	
		--spawn slime!
		local spawner = math.random(1000)
		local keeper = {}
		if spawner < 10 then
			table.insert(title_slimes, tslime())
		end
		
		for _, t in ipairs(title_slimes) do
			t:update(dt)
			if t.y < love.graphics.getHeight() then
				table.insert(keeper, t)
			end
		end
		title_slimes = keeper
		
		title_glow = title_glow + tglower
		if title_glow > 150 then
			tglower = -100 * dt
			title_glow = 150
		elseif title_glow < 100 then
			tglower = 100 * dt
			title_glow = 100
		end
		
		--Fade text if nothing is pressed
		tfader = tfader + (10 * dt)
		if tfader > 10 then
			tfade = tfade  - (50 * dt)
			if tfade < 0 then tfade = 0 end
		end
		function love.keypressed()
			tfader = 0
			tfade = 255
		end
		
		--allow changing of gore effect on title screen
		if love.keyboard.isDown("f8") and not k_f8 then
			s_scroll:stop()
			s_scroll:play()
			k_f8 = true
			if prefs.gore == "none" then
				prefs.gore = "low"
			elseif prefs.gore == "low" then
				prefs.gore = "full"
			else
				prefs.gore = "none"
			end
		elseif not love.keyboard.isDown("f8") then
			k_f8 = nil
		end
	--MAIN GAME-----------------------------------------------------------+
	elseif state == "action" and not prefs.pause then --temporary gameplay state
		--take input
		player1:control(dt)		
		
		--HANDLE ZOMBINOS
		for _, zombo in ipairs(zombies) do
			zombo:update(dt)
			zombo:collide(dt, player1)
		end
		
		--update player
		player1:update(dt)

		
		--BLOOD EFFECTS
		--draw more blood!
		if prefs.gore == "full" then
			love.graphics.setRenderTarget(blood_buffer)
			if blood_raster then
				love.graphics.setColor(255, 255, 255, 255)
				love.graphics.draw(blood_raster, 0, 0)
			end
			for _, zb in ipairs(bloodshed) do
				zb:draw()
			end
			love.graphics.setRenderTarget()		
			--raster blood if needed
			if # bloodshed > 10 then
				blood_data = blood_buffer:getImageData()
				blood_raster = love.graphics.newImage(blood_data)
				bloodshed = {}
			end
		elseif # bloodshed > 10 then --BLOOD IS SET TO LOW
			local bldshd = {}
			local amtobld = # bloodshed - 1
			for i = 1, # bloodshed - 1 do
				bldshd[i] = bloodshed[i + 1]
			end
			bloodshed = bldshd
		end

		--HANDLE ITEMS
		for _, i in ipairs(item_stack) do
			i:update(dt)
		end
		
		--thanks to sharpobject for this block of code
		zombies_deadcheck = {}
		for _, zombo in ipairs(zombies) do
			if not zombo:dead() then
				zombies_deadcheck[#zombies_deadcheck + 1] = zombo
			end
		end
		zombies, zombies_deadcheck = zombies_deadcheck, zombies
		--cheers man!
		
		--deadz1
		if player1.status == "dead" then
			state = "gameover"
			counter = 0
			blinky = ""
		end
		
		--add more zombies!!
		add_more = add_more + (math.random(10) * dt)
		if # zombies <= 50  and add_more > 25 then
			for _ = 1, math.random(5) do
				table.insert(zombies, zombie(player1))
			end
			add_more = 0
		end
		
		if love.keyboard.isDown("escape") then
			s_drone:stop()
			s_hit:stop()
			state = "title"
			title_init()
		end
	--GAME OVER-----------------------------------------------------------+
	elseif state == "gameover" then --temporary gameover state
		--Gameover code
		--HIGH SCORES ENTRY
		function love.keypressed(key, unicode)
			if key == "backspace" then
				player1.name = player1.name:sub(1, player1.name:len() - 1)
			elseif unicode < 166 and unicode > 31 and player1.name:len() < 25 then
				player1.name = player1.name .. string.char(unicode)
			end
		end
		
		--blinking cursor
		counter = counter - (10 * dt)
		if counter < 0 then
			if blinky ~= "[]" then
				blinky = "[]"
				counter = 7
			else
				blinky = ""
				counter = 2
			end
		end
		
		--if the music isn't playing, then play it
		if s_creepy:isStopped() then
			s_drone:stop()
			s_creepy:play()
		end
		--enter key starts new game/confirms text entry
		if love.keyboard.isDown("return") then
			k_ret = true
			s_creepy:stop()
			s_start:stop()
			s_start:play()
			dev_init()
			function love.keypressed(key, unicode) end
		end
		--escape returns to title/confirms text entry
		if love.keyboard.isDown("escape") then
			s_creepy:stop()
			state = "title"
			title_init()
			function love.keypressed(key, unicode) end
		end
	end
end