--[[
	ZOMBIE ENTITY
	May need a future rewrite to inherit from another class, along with the player class. Not much point now though, done too much? :/
]]--

class "zombie" {
	__init__ = function(self, player)
		self.x = math.random(love.graphics.getWidth())
		if math.abs(player.x - self.x) < 16 then
			self.x = self.x + 32
		end
		self.y = math.random(love.graphics.getHeight())
		if math.abs(player.y - self.y) < 16 then
			self.y = self.y + 32
		end
		self.vx = 0
		self.vy = 0
		self.hp = math.random(3, 5)
		self.maxhp = self.hp
		self.speed = math.random(3, 25)
		self.ai = math.random(3)
		--self.ai = 1
		self.cool = 0
		self.w = 16
		self.h = 16
		self.dmg = math.random(15, 30)
		self.push = 8
		self.green = math.random(-20, 20)
		s_zom_spawn:stop()
		s_zom_spawn:play()
	end,
	
	--[[
		ZOMBIE AIs
		1: The zombie will 'buzz' around, not realy doing anything.
		2: The zombie will to a random point on the map (this is activated by default if the zombie leaves the screen)
		3: The zombie will attempt to kill the player
		4: Savage zombie. Will attack a single target until it is dead, then attack a new one.
	]]--
	update = function(self, dt)
		--if last action cooldown is completed:
		if self.cool <= 0 then
			--check AI and move
			
			if self.ai == 1 then
				--BUZZZZZZZZ
				self.vx = self.vx + ((math.random(-3, 3) * self.speed) * dt)
				self.vy = self.vy + ((math.random(-3, 3) * self.speed) * dt)
				self.cool = 0.45
				
			elseif self.ai == 2 then
				--WALK TO A POINT
				if not self.target then
					self.target = {}
					--assign target to a random point within the 'map'
					self.target.x = math.random(20, love.graphics.getWidth() - 20)
					self.target.y = math.random(40, love.graphics.getHeight() - 20)
				else
					--go!
					self:pursue(dt)
					--check if the destination is reached
					if self.x < self.target.x + 2 and self.x > self.target.x - 2 and self.y < self.target.y + 2 and self.y > self.target.y - 2 then	
						self.target = nil
						if not self.movein then --self.movein is defined if the zombie walked/generated out of bounds
							self.cool = math.random(4, 10)
						else
							self.movein = nil
							self.ai = 1
						end
					end
				end
				
			elseif self.ai == 3 then
				--ATTAAAAAAAACK!
				if not self.target then
					self.target = player1
				else
					--go!
					self:pursue(dt)
					--check if the destination is reached
					if self.x < self.target.x + 2 and self.x > self.target.x - 2 and self.y < self.target.y + 2 and self.y > self.target.y - 2 then	
						self.cool = math.random(1, 2)
					end
				end
			--END AI	
			end
			--END AI
		else
			self.cool = self.cool - 2 * dt --if cooling down, then do so
		end
		
		--if out of bounds, move back in (if not attacking))
		if self.x < 20 or self.x > love.graphics.getWidth() - 20 or self.y < 20 or self.y > love.graphics.getHeight() - 20 then
			if self.ai ~= 3 then
				self.movein = true
				self.ai = 2
			end
		end
		
		--check if the zombie was attacked and make it invincible for a second
		if self.inv then
			self.inv = self.inv - (15 * dt)
			if self.inv <= 0 then self.inv = nil end
		end
		

		
	end,
	
	--DRAW THE ZOMBOLINSKI
	draw = function(self)
		local b = 100 - math.floor((self.hp / self.maxhp) * 100)
		if not self.inv then
			love.graphics.setColor(74, 109 + self.green, 59 + b, 255)	
			self.flash = nil
		else
			if math.floor(self.inv) % 2 == 0 then
				if not self.flash or self.flash == 0 then
					self.flash = 255
				else
					self.flash = 0
				end
			end
		love.graphics.setColor(74, 109 + self.green, 59 + b, self.flash)
		end
		love.graphics.rectangle("fill", math.floor(self.x), math.floor(self.y), self.w, self.h)
		--love.graphics.print(self.hp, self.x, self.y - 15)
	end,
	
	--collision hit thing (DAMAGE CODE)
	hit = function(self, player)
		--take damage
		self.hp = self.hp - player.weapons[player.equipped].dmg
		self.inv = 5
		--reduce ammo(temp) and increase score
		player.score = player.score + 1.3 + (self.speed / 3.9)
		table.insert(bloodshed, blood(self.x, self.y))
		if player.weapons[player.equipped].ammo and not player.ammo_redux then
			player.weapons[player.equipped].ammo = player.weapons[player.equipped].ammo - 1
			player.ammo_redux = true
		end
		--play sound effects
		s_zom_dmg:stop()
		s_zom_dmg:play()
	end,
	
	collide = function(self, dt, player)
		--player/zombie collide
		if overlap(self.x, self.y, self.w, self.h, player.x - 1, player.y - 1, player.w + 1, player.h + 1) then
			--[[if s_hit:isStopped() then
				s_hit:play()
			end--]]
			
			local vx = 0
			local vy = 0
			--check y
			if player.y + (player.h / 2) < self.y + (self.h / 2) then
				vy = player.vy - (self.push  * (10 * dt))
			else
				vy = player.vy + (self.push * (10 * dt))
			end
			
			--check x
			if player.x + (player.w / 2) < self.x + (player.w / 2) then
				vx = player.vx - (self.push * (10 * dt))
			else
				vx = player.vx + (self.push * (10 * dt))
			end
			
			if not player.inv then
				s_dmg:stop()
				s_dmg:play()
				player.hp = player.hp - (self.dmg * (100 * dt))
				player.inv = 10
				if player.dir == "n" then
					vy = vy + 12 - vy
				elseif player.dir == "e" then
					vx = vx - 12 - vx
				elseif player.dir == "s" then
					vy = vy - 12 - vx
				else
					vx = vx + 12 - vy
				end
			end
			
			player.vx = vx
			player.vy = vy
			
			--[[
			if player.y > self.y then
				player.y = player.y + (self.push + player.h / 2)
			elseif player.x < self.x then
				player.x = player.x - (self.push + player.w / 2)
			elseif player.y < self.y then
				player.y = player.y - (self.push + player.h / 2)
			else
				player.x = player.x + (self.push + player.w / 2)
			end
			]]--
		else
			--s_hit:stop()
		end
		
		--weapon/zombie collide
		if player.act == "atk" and not self.inv then --if player is attacking and zombie is eligible to take damage
			if player.dir == "n" then
				if overlap(self.x - 1, self.y - 1, self.w + 2, self.h + 2, player.x + (player.w / 2) - (player.weapons[player.equipped].w / 2), player.y - player.weapons[player.equipped].h, player.weapons[player.equipped].w, player.weapons[player.equipped].h) then
					self.vy = self.vy - (self.w / 4) - player.weapons[player.equipped].push
					self:hit(player)
				end
			elseif player.dir == "e" then
				if overlap(self.x - 1, self.y - 1, self.w + 2, self.h + 2, player.x + player.w, player.y + (player.h / 2) - (player.weapons[player.equipped].w / 2), player.weapons[player.equipped].h, player.weapons[player.equipped].w) then
					self.vx = self.vx + (self.w / 4) + player.weapons[player.equipped].push
					self:hit(player)
				end
			elseif player.dir == "s" then
				if overlap(self.x - 1, self.y - 1, self.w + 2, self.h + 2, player.x + (player.w / 2) - (player.weapons[player.equipped].w / 2), player.y + player.h, player.weapons[player.equipped].w, player.weapons[player.equipped].h) then
					self.vy = self.vy + (self.h / 4) + player.weapons[player.equipped].push
					self:hit(player)
				end
			else
				if overlap(self.x - 1, self.y - 1, self.w + 2, self.h + 2, player.x - player.weapons[player.equipped].h, player.y + (player.h / 2) - (player.weapons[player.equipped].w / 2), player.weapons[player.equipped].h, player.weapons[player.equipped].w) then
					self.vx = self.vx - (self.w / 4) - player.weapons[player.equipped].push
					self:hit(player)
				end
			end
		end
		
		--reposition
		self.x = self.x + self.vx
		self.y = self.y + self.vy
		self.vx = 0
		self.vy = 0
		
	end,
	
	--move the zombie towards the target
	pursue = function(self, dt, target)
		local vel = self.speed * (2 * dt)
		local x_v = self.x - self.target.x
		local y_v = self.y - self.target.y
		--[[
		self.x = self.x - ((x_v / math.abs(y_v)) * vel)
		self.y = self.y - ((y_v / math.abs(x_v)) * vel)
		]]--
		
		if self.x < self.target.x then
			self.vx = self.vx + vel
		elseif self.x > self.target.x then
			self.vx = self.vx - vel
		end
		
		if self.y < self.target.y then
			self.vy = self.vy + vel
		elseif self.y > self.target.y then
			self.vy = self.vy - vel
		end
		
	end,
	
	--check if the zombie is dead…
	dead = function(self)
		if self.hp <= 0 then
			s_zom_death:stop()
			s_zom_death:play()
			local drop = math.random(200) - self.speed
			if drop < 5 then
				local drop2 = math.random(100)
				if drop2 < 25 then
					table.insert(item_stack, item(self.x + 4, self.y + 4))
				elseif drop2 >= 26 and drop2 <= 50 then
					table.insert(item_stack, item(self.x + 4, self.y + 4, wpn("Short Sword", 1, 40, 6, 14, 2)))
				elseif drop2 >= 51 and drop2 <= 65 then
					table.insert(item_stack, item(self.x + 4, self.y + 4, wpn("Broad Sword", 1.75, 30, 10, 16, 2)))
				elseif drop2 >= 66 and drop2 <= 80 then
					table.insert(item_stack, item(self.x + 4, self.y + 4, wpn("Long Sword", 1.3, 30, 6, 20, 3)))
				elseif drop2 >= 81 and drop2 <= 90 then
					table.insert(item_stack, item(self.x + 4, self.y + 4, wpn("Scramasax", 2.5, 25, 4, 12, 3)))
				elseif drop2 >= 91 then
					table.insert(item_stack, item(self.x + 4, self.y + 4, wpn("Magick Sword", 4, 20, 8, 16, 6, "stab", {255, 175, 100, 175}, s_magick)))
				end
			end
			return true
		end
	end
}
			
